Index: /trunk/interface/DataConverter.h
===================================================================
--- /trunk/interface/DataConverter.h	(revision 356)
+++ /trunk/interface/DataConverter.h	(revision 357)
@@ -49,5 +49,5 @@
   DataConverter() : Nevt(-1) {};
   DataConverter(const int &N) : Nevt(N) {};
-  ~DataConverter() {};
+  virtual ~DataConverter() {};
 
 private:
Index: /trunk/interface/HEPEVTConverter.h
===================================================================
--- /trunk/interface/HEPEVTConverter.h	(revision 356)
+++ /trunk/interface/HEPEVTConverter.h	(revision 357)
@@ -67,5 +67,5 @@
 
   HEPTreeReader(TTree *tree, HEPEvent *event);
-  ~HEPTreeReader();
+  virtual ~HEPTreeReader();
 
   Long64_t GetEntries() const { return fChain ? static_cast<Long64_t>(fChain->GetEntries()) : 0; }
Index: unk/interface/HEPMCConverter.h
===================================================================
--- /trunk/interface/HEPMCConverter.h	(revision 356)
+++ 	(revision )
@@ -1,48 +1,0 @@
-#ifndef _HEPMCCONVERTER_H_
-#define _HEPMCCONVERTER_H_
-
-/***********************************************************************
-**                                                                    **
-**          /----------------------------------------------\          **
-**         |  Delphes, a framework for the fast simulation  |         **
-**         |       of a  generic collider experiment        |         **
-**          \-------------  arXiv:0903.2225v1  ------------/          **
-**                                                                    **
-**                                                                    **
-**   This package uses:                                               **
-**   ------------------                                               **
-**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      ** 
-**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       ** 
-**   FROG: [hep-ex/0901.2718v1]                                       **
-**                                                                    **
-** ------------------------------------------------------------------ **
-**                                                                    **
-**   Main authors:                                                    **
-**   -------------                                                    **
-**                                                                    **
-**                Severine Ovyn                Xavier Rouby           ** 
-**          severine.ovyn@uclouvain.be      xavier.rouby@cern         ** 
-**                                                                    ** 
-**         Center for Particle Physics and Phenomenology (CP3)        ** 
-**                Universite catholique de Louvain (UCL)              **       
-**                     Louvain-la-Neuve, Belgium                      **            
-**                                                                    **
-**                      Copyright (C) 2008-2009,                      **
-**                        All rights reserved.                        **  
-**                                                                    **
-***********************************************************************/
-
-
-#include <string>
-#include "DataConverter.h"
-
-using namespace std;
-
-class HEPMCConverter : public DataConverter {
-  public:
-    HEPMCConverter(const string& inputFileList, const string& outputFileName, const int& Nevents=-1);
-    ~HEPMCConverter();
-
-};
-
-#endif
Index: /trunk/interface/LHEFConverter.h
===================================================================
--- /trunk/interface/LHEFConverter.h	(revision 356)
+++ /trunk/interface/LHEFConverter.h	(revision 357)
@@ -50,5 +50,5 @@
 
   LHEFConverter(const string& inputFileList, const string& outputFileName, const int& Nevents=-1);
-  ~LHEFConverter();
+  virtual ~LHEFConverter();
 
 private:
Index: /trunk/interface/STDHEPConverter.h
===================================================================
--- /trunk/interface/STDHEPConverter.h	(revision 356)
+++ /trunk/interface/STDHEPConverter.h	(revision 357)
@@ -42,5 +42,5 @@
   public:
     STDHEPConverter(const string& inputFileList, const string& outputFileName, const int& Nevents=-1);
-    ~STDHEPConverter();
+    virtual ~STDHEPConverter();
 
   private: