Index: cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_0PU.tcl
===================================================================
--- cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_0PU.tcl	(revision 23389ff3a092403c3a099c8af2cc8f45338abbed)
+++ cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_0PU.tcl	(revision 367b2e18e350b00d246bd343a48ca8ca4bfc35a3)
@@ -50,10 +50,12 @@
 
   PhotonFilter
-
+  
+  PhotonCloner
   PhotonIsolation
   PhotonIsolationCHS
   PhotonEfficiency
   PhotonEfficiencyCHS
-
+  
+  ElectronCloner
   ElectronIsolation
   ElectronIsolationCHS
@@ -62,4 +64,5 @@
   ElectronEfficiencyCHS
 
+  MuonCloner
   MuonIsolation
   MuonIsolationCHS
@@ -153,6 +156,6 @@
 
 module ParticlePropagator ParticlePropagator {
-  #set InputArray PileUpMerger/stableParticles
-  set InputArray Delphes/stableParticles
+  set InputArray PileUpMerger/stableParticles
+  #set InputArray Delphes/stableParticles
 
   set OutputArray stableParticles
@@ -955,4 +958,32 @@
 
 
+##################
+# Muon cloner    #
+##################
+
+module Cloner MuonCloner {
+  set InputArray MuonMomentumSmearing/muons
+  set OutputArray muons
+}
+
+####################
+# Electron cloner  #
+####################
+
+module Cloner ElectronCloner {
+  set InputArray ElectronFilter/electrons
+  set OutputArray electrons
+}
+
+##################
+# Photon cloner  #
+##################
+
+module Cloner PhotonCloner {
+  set InputArray PhotonFilter/photons
+  set OutputArray photons
+}
+
+
 ####################
 # Photon isolation #
@@ -993,5 +1024,5 @@
 
   # particle for which calculate the isolation
-  set CandidateInputArray PhotonFilter/photons
+  set CandidateInputArray PhotonCloner/photons
 
   # isolation collection
@@ -1079,5 +1110,5 @@
 module Isolation ElectronIsolationCHS {
 
-  set CandidateInputArray ElectronFilter/electrons
+  set CandidateInputArray ElectronCloner/electrons
 
   # isolation collection
@@ -1182,4 +1213,5 @@
 
 
+
 ##################
 # Muon isolation #
@@ -1205,5 +1237,5 @@
 
 module Isolation MuonIsolationCHS {
-  set CandidateInputArray MuonMomentumSmearing/muons
+  set CandidateInputArray MuonCloner/muons
 
   # isolation collection
Index: cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_200PU.tcl
===================================================================
--- cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_200PU.tcl	(revision 23389ff3a092403c3a099c8af2cc8f45338abbed)
+++ cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_200PU.tcl	(revision 367b2e18e350b00d246bd343a48ca8ca4bfc35a3)
@@ -50,10 +50,12 @@
 
   PhotonFilter
-
+  
+  PhotonCloner
   PhotonIsolation
   PhotonIsolationCHS
   PhotonEfficiency
   PhotonEfficiencyCHS
-
+  
+  ElectronCloner
   ElectronIsolation
   ElectronIsolationCHS
@@ -62,4 +64,5 @@
   ElectronEfficiencyCHS
 
+  MuonCloner
   MuonIsolation
   MuonIsolationCHS
@@ -955,4 +958,32 @@
 
 
+##################
+# Muon cloner    #
+##################
+
+module Cloner MuonCloner {
+  set InputArray MuonMomentumSmearing/muons
+  set OutputArray muons
+}
+
+####################
+# Electron cloner  #
+####################
+
+module Cloner ElectronCloner {
+  set InputArray ElectronFilter/electrons
+  set OutputArray electrons
+}
+
+##################
+# Photon cloner  #
+##################
+
+module Cloner PhotonCloner {
+  set InputArray PhotonFilter/photons
+  set OutputArray photons
+}
+
+
 ####################
 # Photon isolation #
@@ -993,5 +1024,5 @@
 
   # particle for which calculate the isolation
-  set CandidateInputArray PhotonFilter/photons
+  set CandidateInputArray PhotonCloner/photons
 
   # isolation collection
@@ -1079,5 +1110,5 @@
 module Isolation ElectronIsolationCHS {
 
-  set CandidateInputArray ElectronFilter/electrons
+  set CandidateInputArray ElectronCloner/electrons
 
   # isolation collection
@@ -1182,4 +1213,5 @@
 
 
+
 ##################
 # Muon isolation #
@@ -1205,5 +1237,5 @@
 
 module Isolation MuonIsolationCHS {
-  set CandidateInputArray MuonMomentumSmearing/muons
+  set CandidateInputArray MuonCloner/muons
 
   # isolation collection