Index: trunk/data/DetectorCard.dat
===================================================================
--- trunk/data/DetectorCard.dat	(revision 382)
+++ trunk/data/DetectorCard.dat	(revision 383)
@@ -79,4 +79,5 @@
 JET_jetalgo      1              // 1 for Cone algorithm, 2 for MidPoint algorithm, 3 for SIScone algorithm, 4 for kt algorithm
 JET_seed         1.0            // minimum seed to start jet reconstruction, in GeV
+JET_Eflow        1              // Perfect energy assumed in the tracker coverage
 
 # Tagging definition
Index: trunk/data/DetectorCard_ATLAS.dat
===================================================================
--- trunk/data/DetectorCard_ATLAS.dat	(revision 382)
+++ trunk/data/DetectorCard_ATLAS.dat	(revision 383)
@@ -81,4 +81,5 @@
 JET_jetalgo      1              // 1 for Cone algorithm, 2 for MidPoint algorithm, 3 for SIScone algorithm, 4 for kt algorithm
 JET_seed         1.0            // minimum seed to start jet reconstruction, in GeV
+JET_Eflow        1              // Perfect energy assumed in the tracker coverage
 
 # Tagging definition
Index: trunk/data/DetectorCard_CMS.dat
===================================================================
--- trunk/data/DetectorCard_CMS.dat	(revision 382)
+++ trunk/data/DetectorCard_CMS.dat	(revision 383)
@@ -81,4 +81,5 @@
 JET_jetalgo      1              // 1 for Cone algorithm, 2 for MidPoint algorithm, 3 for SIScone algorithm, 4 for kt algorithm
 JET_seed         1.0            // minimum seed to start jet reconstruction, in GeV
+JET_Eflow        1              // Perfect energy assumed in the tracker coverage
 
 # Tagging definition
Index: trunk/interface/SmearUtil.h
===================================================================
--- trunk/interface/SmearUtil.h	(revision 382)
+++ trunk/interface/SmearUtil.h	(revision 383)
@@ -215,4 +215,5 @@
  int NEvents_Frog;
  float PT_QUARKS_MIN;    // minimal pt needed for quarks to reach the tracker, in GeV
+ int JET_Eflow;
 
  string PdgTableFilename;
Index: trunk/src/SmearUtil.cc
===================================================================
--- trunk/src/SmearUtil.cc	(revision 382)
+++ trunk/src/SmearUtil.cc	(revision 383)
@@ -127,4 +127,5 @@
   JET_jetalgo      = 1;              // 1 for Cone algorithm, 2 for MidPoint algorithm, 3 for SIScone algorithm, 4 for kt algorithm
   JET_seed         = 1.0;            // minimum seed to start jet reconstruction
+  JET_Eflow        = 1;		     // 1 for Energy flow in jets reco ; 0 if not
 
   // Tagging definition
@@ -272,4 +273,5 @@
   JET_jetalgo      = DET.JET_jetalgo;
   JET_seed         = DET.JET_seed;
+  JET_Eflow        = DET.JET_Eflow;
 
   // Tagging definition
@@ -409,4 +411,5 @@
   JET_jetalgo      = DET.JET_jetalgo;
   JET_seed         = DET.JET_seed;
+  JET_Eflow        = DET.JET_Eflow;
 
   // Tagging definition
@@ -574,4 +577,5 @@
     else if(strstr(temp_string.c_str(),"JET_jetalgo"))      {curstring >> varname >> ivalue;JET_jetalgo       = ivalue;}
     else if(strstr(temp_string.c_str(),"JET_seed"))         {curstring >> varname >> value; JET_seed          = value;}
+    else if(strstr(temp_string.c_str(),"JET_Eflow"))        {curstring >> varname >> value; JET_Eflow         = value;}
  
     else if(strstr(temp_string.c_str(),"BTAG_b"))           {curstring >> varname >> ivalue;BTAG_b            = ivalue;}
@@ -907,4 +911,14 @@
   f_out<<"# Jet definition                                                     *"<<"\n";
   f_out<<"#***************                                                     *"<<"\n";
+  if(JET_Eflow)
+    {
+      f_out<<"#***************                                                     *"<<"\n";
+      f_out<<"#*  Running considering perfect energy flow on the tracker coverage  *"<<"\n";
+    }
+  else
+    {
+      f_out<<"#*     Running considering no energy flow on the tracker coverage    *"<<"\n";
+      f_out<<"#*         --> jet algo applied on the calorimetric towers           *"<<"\n";
+    }
   f_out<<"*                                                                    *"<<"\n";
   f_out<<"*  Six algorithms are currently available:                           *"<<"\n";