Index: /trunk/Delphes.cpp
===================================================================
--- /trunk/Delphes.cpp	(revision 400)
+++ /trunk/Delphes.cpp	(revision 401)
@@ -4,5 +4,5 @@
 **         |  Delphes, a framework for the fast simulation  |         **
 **         |       of a  generic collider experiment        |         **
-**          \----------------------------------------------/          **
+**          \-------------  arXiv:0903.2225v1  ------------/          **
 **                                                                    **
 **                                                                    **
@@ -98,59 +98,6 @@
     exit(1);
   }
-  
-  cout << endl << endl;
-  
-  cout <<"*********************************************************************"<< endl;
-  cout <<"*********************************************************************"<< endl;
-  cout <<"**                                                                 **"<< endl;
-  cout <<"**                            Welcome to                           **"<< endl;
-  cout <<"**                                                                 **"<< endl;
-  cout <<"**                                                                 **"<< endl;
-  cout <<"**     .ddddddd-            lL             hH                      **"<< endl;
-  cout <<"**     -Dd` `dD:           Ll             hH`                      **"<< endl;
-  cout <<"**     dDd   dDd    eeee.  lL  .pp+pp    Hh+hhh`   -eeee- `sssss   **"<< endl;
-  cout <<"**    -Dd   `DD   ee. ee  Ll   .Pp. PP   Hh. HH.  ee. ee  sSs      **"<< endl;
-  cout <<"**    dD`   dDd  eEeee:   lL.  pP.  pP  hH   hH` eEeee:` -sSSSs.   **"<< endl;
-  cout <<"**   .Dd  :dd    eE.     LlL   PpppPP   Hh  Hh   eE         sSS    **"<< endl;
-  cout <<"**   dddddd:.     eee+:  lL.  pp.      hh.  hh    eee+  sssssS     **"<< endl;
-  cout <<"**                            Pp                                   **"<< endl;
-  cout <<"**                                                                 **"<< endl;
-  cout <<"**           Delphes, a framework for the fast simulation          **"<< endl;
-  cout <<"**                 of a  generic collider experiment               **"<< endl;
-  cout <<"**                    arXiv:0903.2225v1 [hep-ph]                   **"<< endl;
-  cout <<"**                                                                 **"<< endl;
-  cout <<"**                  --- Version 1.6 of Delphes ---                 **"<< endl;
-  cout <<"**                Last date of change:    7 May 2009               **"<< endl;
-  cout <<"**                                                                 **"<< endl;
-  cout <<"**                                                                 **"<< endl;
-  cout <<"**     This package uses:                                          **"<< endl;
-  cout <<"**     ------------------                                          **"<< endl;
-  cout <<"**     FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210] **"<< endl;
-  cout <<"**     Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]  **"<< endl;
-  cout <<"**     FROG:                               [hep-ex/0901.2718v1]    **"<< endl;
-  cout <<"**                                                                 **"<< endl;
-  cout <<"**-----------------------------------------------------------------**"<< endl;
-  cout <<"**                                                                 **"<< endl;
-  cout <<"**   Main authors:                                                 **"<< endl;
-  cout <<"**   -------------                                                 **"<< endl;
-  cout <<"**                                                                 **"<< endl;
-  cout <<"**              SÃ©verine Ovyn               Xavier Rouby           **"<< endl;
-  cout <<"**       severine.ovyn@uclouvain.be      xavier.rouby@cern         **"<< endl;
-  cout <<"**       Center for Particle Physics and Phenomenology (CP3)       **"<< endl;
-  cout <<"**       Universite Catholique de Louvain (UCL)                    **"<< endl;
-  cout <<"**       Louvain-la-Neuve, Belgium                                 **"<< endl;
-  cout <<"**                                                                 **"<< endl;
-  cout <<"**-----------------------------------------------------------------**"<< endl;
-  cout <<"**                                                                 **"<< endl;
-  cout <<"**   Former Delphes versions and documentation can be found on :   **"<< endl;
-  cout <<"**               http://www.fynu.ucl.ac.be/delphes.html            **"<< endl;
-  cout <<"**                                                                 **"<< endl;
-  cout <<"**                                                                 **"<< endl;
-  cout <<"**   Disclaimer: this program is a beta version of Delphes and     **"<< endl;
-  cout <<"** therefore comes without guarantees. Beware of errors and please **"<< endl;
-  cout <<"**        give us your feedbacks about potential bugs              **"<< endl;
-  cout <<"**                                                                 **"<< endl;
-  cout <<"*********************************************************************"<< endl;
-  cout <<"*********************************************************************"<< endl;
+
+  print_header();  
   
   // 1. ********** initialisation ***********
@@ -228,6 +175,6 @@
   cout <<"**                                                                 **"<< endl;
   DET->ReadParticleDataGroupTable();
-  //DET->PDGtable.print();
-  
+ // DET->PDGtable.print();
+ 
   //Trigger information
   cout <<"**        ########### Start reading TRIGGER card ##########        **"<< endl;